#include "editdialog.h"
// #include "ui_editdialog.h"
#include <QTextStream>
#include <QMessageBox>

#include <QtCore/QVariant>
#include <QtWidgets/QAction>
#include <QtWidgets/QApplication>
#include <QtWidgets/QButtonGroup>
#include <QtWidgets/QDialog>
#include <QtWidgets/QDialogButtonBox>
#include <QtWidgets/QHBoxLayout>
#include <QtWidgets/QHeaderView>
#include <QtWidgets/QLabel>
#include <QtWidgets/QPushButton>
#include <QtWidgets/QVBoxLayout>
#include <QtWidgets/QWidget>

EditDialog::EditDialog(QStringList *thedic, QWidget *parent) :
    QDialog(parent)
{
    PpalDico = thedic;
    // Recopie du dico entrant
    localDico = new QStringList((const QList<QString> &) *thedic);
    // Construction d'une listView à partir du localDico
    modele = new QStringListModel(this);
    listView = new QListView(this);
    listView->setEditTriggers(QAbstractItemView::AnyKeyPressed|QAbstractItemView::DoubleClicked);

    // Fabrication de la fenetre graphique
    //---------------------------------------------
    QVBoxLayout *mainlayoutV = new QVBoxLayout(this);
    // Ajout 1ere ligne : Label(Mot) et LineEditMot
    QHBoxLayout *layoutL = new QHBoxLayout();
    QLabel *label = new QLabel(this);
    label->setText("Mot");
    lineEditMot = new QLineEdit(this);
    layoutL->addWidget(label);
    layoutL->addWidget(lineEditMot);
    mainlayoutV->addLayout(layoutL);
    // Ajout 2ème ligne : Bouton(Ajouter) + Bouton(supprimer)
    layoutL = new QHBoxLayout();
    QPushButton *pushButton_Ajouter = new QPushButton(this);
    pushButton_Ajouter->setText("Ajouter");
    QPushButton *pushButton_Supprimer = new QPushButton(this);
    pushButton_Supprimer->setText("Supprimer");
    layoutL->addWidget(pushButton_Ajouter);
    layoutL->addWidget(pushButton_Supprimer);
    mainlayoutV->addLayout(layoutL);
    connect(pushButton_Ajouter,SIGNAL(clicked(bool)),this,SLOT(on_pushButton_Ajouter_clicked()));
    connect(pushButton_Supprimer,SIGNAL(clicked(bool)),this,SLOT(on_pushButton_Supprimer_clicked()));
    // Ajout de la ListView
    mainlayoutV->addWidget(listView);
    // Ajout Bouton(OK) + Bouton(Cancel)
    QDialogButtonBox *buttonBox = new QDialogButtonBox(this);
    buttonBox->setOrientation(Qt::Horizontal);
    buttonBox->setStandardButtons(QDialogButtonBox::Cancel|QDialogButtonBox::Ok);
    mainlayoutV->addWidget(buttonBox);
    connect(buttonBox, SIGNAL(accepted()), this, SLOT(on_buttonBox_accepted()));
    connect(buttonBox, SIGNAL(rejected()), this, SLOT(on_buttonBox_rejected()));
    // Ajout du mainLayoutH au Dialogue
    setLayout(mainlayoutV);
}

int EditDialog::exec()
{
    modele->setStringList(*localDico);
    listView->setModel(modele);
    return QDialog::exec();
}

void EditDialog::on_pushButton_Ajouter_clicked()
{
    QString s = lineEditMot->text();
    // Si le lineEditMot n'est pas vide
    if (!s.isNull() && !s.isEmpty() && s.size() > 0)
    {
        // On l'ajoute au localDico et on le ré-ordonne
        localDico->append(s);
        localDico->sort();
        localDico->removeDuplicates();
        // On met à jour le listView
        modele->setStringList(*localDico);
        listView->setModel(modele);
        lineEditMot->setText("");
    }
}

void EditDialog::on_pushButton_Supprimer_clicked()
{
    int i = listView->currentIndex().row();
    if (i >= 0 && i < modele->rowCount())
    {
        modele->removeRows(i,1);
        localDico->removeAt(i);
    }
}

void EditDialog::on_buttonBox_accepted()
{
// On remplace le PpalDico par le localDico
    PpalDico->clear();
    PpalDico->append(*localDico);
    accept();
}

void EditDialog::on_buttonBox_rejected()
{
// On remet le localDico en conformité avec lePpalDico
    localDico->clear();
    localDico->append(*PpalDico);
    reject();
}
