#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QStringList>
#include <QFile>
#include <QTextStream>
#include "editdialog.h"
#include <QProgressBar>
#include <QLineEdit>
#include <QTextEdit>
#include <QtCore/QVariant>
#include <QtWidgets/QAction>
#include <QtWidgets/QApplication>
#include <QtWidgets/QButtonGroup>
#include <QtWidgets/QCheckBox>
#include <QtWidgets/QHBoxLayout>
#include <QtWidgets/QHeaderView>
#include <QtWidgets/QLabel>
#include <QtWidgets/QLineEdit>
#include <QtWidgets/QMainWindow>
#include <QtWidgets/QProgressBar>
#include <QtWidgets/QPushButton>
#include <QtWidgets/QSpacerItem>
#include <QtWidgets/QSpinBox>
#include <QtWidgets/QStatusBar>
#include <QtWidgets/QTextEdit>
#include <QtWidgets/QToolBar>
#include <QtWidgets/QVBoxLayout>
#include <QtWidgets/QWidget>


class MyThread;





class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    friend class MyThread;
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();

private:
    MyThread *recherche;

    QFile *filein;
    QTextStream *in;
    QStringList mindico1; // dico 1 en minuscules
    QStringList mindico2; // dico 2 en minuscules
    QStringList majdico1; // dico 1 en majuscules
    QStringList majdico2; // dico 2 en majuscules
    EditDialog *myEditDialog;
    int dicSize;
    bool synonyme;
    bool modifs;
    bool cancel;
    int nbautor;
    QString autorises, solution;
    QLabel *labelMots;
    QLabel *labelProto;
    QProgressBar *progressBar;
    QLineEdit *lineEdit_Result;
    QTextEdit *textEdit;
    QSpinBox *spinBox;
    QLineEdit *lettresEdit;
    QCheckBox *checkBox_Concorde;
    QPushButton *button_Scrable;
    QPushButton *button_Xword;
    QPalette *select;
    QPalette *nonsel;
	
private slots:
    void on_pushButton_Cancel_clicked();
    void on_spinBox_editingFinished();
    void on_lineEdit_editingFinished();
    void on_pushButton_Go_clicked();
    void on_pushButton_EditDico_clicked();
 
    void on_checkBox_stateChanged(int arg1);
    void on_button_Scrable();
    void on_button_Xword();

    void aff_avance(int i);
    void aff_trouve(int i);
    void aff_solution();

};

#endif // MAINWINDOW_H
