#include "mythread.h"
#include "mainwindow.h"

MyThread::MyThread(MainWindow *w, QObject *parent) :
    QThread(parent)
{
    win = w;
}

static QString lesA = "ÀÂÅÃÄÁ";
static QString mesA = "AAAAAA";
static QString lesE = "ÉÈÊË";
static QString mesE = "EEEE";
static QString lesI = "ÎÏÍ";
static QString mesI = "III";
static QString lesO = "ÔÓÖ";
static QString mesO = "OOO";
static QString lesU = "ÙÛÜ";
static QString mesU = "UUU";
static QString lesY = "Ÿ";
static QString mesY = "Y";
static QString lesC = "Ç";
static QString mesC = "C";
static QString lesN = "NÑ";
static QString mesN = "NN";
static QString lesS = "S";
static QString mesS = "S";
static QString strOri = lesA + lesE + lesI + lesO + lesU + lesY + lesC + lesN + lesS;
static QString strRep = mesA + mesE + mesI + mesO + mesU + mesY + mesC + mesN + mesS;

void MyThread::run()
{
    int size1 = win->mindico1.size();
    int nbtrouv = 0;
    bool motok;
    QString candidat;
    int nbcharautor = win->autorises.length();
    QChar c, charAutor[256];
    int ksym;

    // Lettres autorisées mises en majuscules
    // et remplacées par synonyme (si désiré) dans charAutor
    for (int j = 0; j < nbcharautor; j++)
    {
        c = win->autorises.toUpper().at(j);
        charAutor[j] = c;
        if (win->synonyme &&(ksym = strOri.indexOf(c)) >= 0) charAutor[j] = strRep.at(ksym);
    }

    if (win->nbautor > 0) // Cas SCRABLE
    {
        QChar bufAutor[256];
        // Inspection des mots du dictionnaire
        for (int i = 0; i < win->dicSize; i++)
        {
            if(i%100 == 0)
            {
                emit avance(i);
                if (win->cancel)
                    break;
            }
            if (i < size1)  candidat = win->majdico1.at(i);
            else candidat = win->majdico2.at(i - size1);
            if (candidat.length() != win->nbautor) continue;
            // Test si candidat i acceptable
            motok = true; // acceptable a priori
            // Lettres autorisees restantes
            for (int j = 0; j < nbcharautor; j++) bufAutor[j] = charAutor[j];
            int ktot = nbcharautor; // Nb de lettres autorisees restantes
            for (int j = 0; j < win->nbautor; j++) // test des lettres candidates
            {
                c = candidat.at(j); // Lettre du mot candidat en cours de test
                if (win->synonyme &&(ksym = strOri.indexOf(c)) >= 0) c = strRep[ksym]; // remplacée par synonyme
                bool lettreok = false; // lettre pas bonne a priori
                for (int k = 0; k < ktot; k++) // Examen par rapport a lettres autorisees
                {
                    if (c == bufAutor[k])
                    {
                        lettreok = true;
                        // on tasse les lettres autorisées
                        for (int kk = k; kk < ktot-1; kk++) bufAutor[kk] = bufAutor[kk+1];
                        ktot--;
                        break; // on sort de ce test
                    }
                }
                if (!lettreok) {motok = false; break;}
            }
            if (motok)
            {
                emit trouve(++nbtrouv);
                if (i < size1)  candidat = win->mindico1.at(i);
                else candidat = win->mindico2.at(i - size1);
                win->solution.append(candidat); win->solution.append("\n");
            }
        }
    }
    else // Cas MOTS-CROISES
    {
        for (int i = 0; i < win->dicSize; i++)
        {
            if(i%100 == 0)
            {
                emit avance(i);
                if (win->cancel)
                    break;
            }
            if (i < size1)  candidat = win->majdico1.at(i);
            else candidat = win->majdico2.at(i - size1);
            if (candidat.length() != nbcharautor) continue;
            motok = true; // acceptable a priori
            for (int j = 0; j < nbcharautor; j++) // test des lettres candidates
            {
//                if(win->autorises.at(j)=='*') continue;
                if(charAutor[j]=='*') continue;
                c = candidat.at(j); // Lettre du mot du dico testée
                if (win->synonyme &&(ksym = strOri.indexOf(c)) >= 0) c = strRep[ksym];  // remplacée par synonyme
                if (c == charAutor[j]) continue;
                motok = false;
                break;
            }
            if (motok)
            {
                if (i < size1)  candidat = win->mindico1.at(i);
                else candidat = win->mindico2.at(i - size1);
                win->solution.append(candidat); win->solution.append("\n");
                emit trouve(++nbtrouv);
            }
        }
    }
}
